﻿-- LGeneral AddOn Options

RT_Options = {
	desc = {
		rarity = {
			[0] = "|c00ffffffOff|r",
			[1] = "|c009d9d9dPoor|r",
			[2] = "|c00ffffffCommon|r",
			[3] = "|c001eff00Uncommon|r",
			[4] = "|c000070ddRare|r",
			[5] = "|c00a335eeEpic|r",
			[6] = "|c00ff8000Legendary|r",
			[7] = "|c00e6cc80Artifact|r",
        },
		logGroup = {
			[0] = "Off", [1] = "Log", [2] = "Auto Create", [3] = "Auto Instance",
		},        
		logAttendees = {
			[0] = "Off", [1] = "On boss kill", [2] = "On loot", [3] = "On boss kill (Zone)",
		},
		logGuild = {
			[0] = "Off", [1] = "On boss kill (All)",  
		},
		autoEvent = {
			[0] = "Off", [1] = "On mouseover", [2] = "On boss kill", [3] = "Ask Next",
		},
		export = {
			[0] = "EQdkp/ML 1.1", [1] = "EQdkp Unknown", [2] = "MLdkp 1.5", [3] = "EQdkp Strict",
		},
		logWipe = {
		    [0] = "Off", [1] = "Log",
		    [2] = "Ask at 10%", [3] = "Ask at 20%",
		    [4] = "Ask at 30%", [5] = "Ask at 40%",
		    [6] = "Ask at 50%",	[7] = "Ask at 60%",
			[8] = "Ask at 70%",	[9] = "Ask at 80%",
		},
		itemopt = {
			[0] = "Default", [1] = "Never", [2] = "Always",
		},
	},
}


function RT_Options:OnShow( frame )
	local o,L = KARaidTrackerDB.Options,RaidTracker.L
    
    RT_OptionsFrameHeaderTitle:SetText(L["RaidTracker Options"])
--    RT_OptionsFrameHeaderText:SetText(L["Options for raids, parties, arenas, bgs, and solo."]);    
    RT_OptionsFrameSection1Title:SetText(L["Logging"]..":")
		RT_OptionsFrame_AutoRaidTitle:SetText(L["Raids"]..":")
		RT_OptionsFrame_AutoPartyTitle:SetText(L["Parties"]..":")
		RT_OptionsFrame_AutoSoloTitle:SetText(L["Solo"]..":")
		RT_OptionsFrame_AutoBattlegroupTitle:SetText(L["Battelgroups"]..":")
		RT_OptionsFrame_AutoArenaTitle:SetText(L["Arenas"]..":")    
		RT_OptionsFrame_LogAttendeesTitle:SetText(L["Attendees"]..":")   
		RT_OptionsFrame_LogGuildTitle:SetText(L["Guild"]..":")   
		RT_OptionsFrame_LogWipeTitle:SetText(L["Wipes"]..":")   
    RT_OptionsFrameSection2Title:SetText(L["Item Quality"]..":")
		RT_OptionsFrame_LogItemsTitle:SetText(L["Min to log"]..":")
		RT_OptionsFrame_CostAskTitle:SetText(L["Min to ask cost"]..":")
		RT_OptionsFrame_CostGetTitle:SetText(L["Min to get cost"]..":")
		RT_OptionsFrame_GroupItemsTitle:SetText(L["Max to group"]..":")
    RT_OptionsFrameSection3Title:SetText(L["Advanced"]..":")
		RT_OptionsFrame_AutoEventTitle:SetText(L["Auto Event"]..":")
		RT_OptionsFrame_LevelMaxTitle:SetText(L["Export level"]..":")
		RT_OptionsFrame_AutoZoneTitle:SetText(L["Auto Zone"]..":")
		RT_OptionsFrame_SaveExtPlayerTitle:SetText(L["Player Detail"]..":")
		RT_OptionsFrame_EventCooldownTitle:SetText(L["Event Cooldown"]..":")
		RT_OptionsFrame_DebugModeTitle:SetText(L["Debug Mode"]..":")
		RT_OptionsFrame_ExportFormatTitle:SetText(L["Export Format"]..":")
		
	local count = table.maxn(self.desc.logGuild)
	for i = 2, count do tremove(self.desc.logGuild, i) end	
	if IsInGuild() then
		GuildRoster(); count = max(GuildControlGetNumRanks(), 1)
		for i = 2, count do	self.desc.logGuild[i] = "("..i..") "..GuildControlGetRankName(i) end
	end
	RT_OptionsFrame_LogGuild:SetMinMaxValues(0, count)

 	for k,v in pairs(RaidTracker._store.defaults.Options) do
 		local e,opt = getglobal("RT_OptionsFrame_" .. k),o[k]
 		if e then
			if e.GetMinMaxValues then local _,x = e:GetMinMaxValues(); if opt > x then opt = x end end
 			if e.SetChecked then e:SetChecked(opt) else e:SetValue(opt) end 
 		end
 	end

end


function RT_Options:OnSave( frame )
 	local o = KARaidTrackerDB.Options
 	
 	for k,v in pairs(RaidTracker._store.defaults.Options) do
 		local e = getglobal("RT_OptionsFrame_" .. k) 	
 		if e then
 			v = e.GetChecked and ((e:GetChecked() == 1) and 1 or 0) or e:GetValue()
 			if o[k] ~= v then o[k] = v end
 		end
 	end
	
	KA_RaidTracker_Update()
	KA_RaidTracker_UpdateView()
end